#  Set up environment variables for GPI IFS Software
#	bash version
#
#  See the GPI Pipeline Installation & Configuration Manual for instructions.
#
# HISTORY:
#       2010-01-25  Created. M. Perrin
#       2010-02-01  Added IDL_DIR, enclosing quotes - M. Perrin
#       2012-02-02  Split out the data from the software
#       2012-08-08  Simplification & reorganization
#       2012-08-10  Rewrite to conform to latest DRP setup - ds
#       2013-10-21  Added descriptions for ease of install - PI

# *** NOTE** This is the sample file for what the GPI environment
# variables should be. You should copy this file to some different
# filename, e.g.  setenv_GPI_custom.csh, in your home dir 
# and edit it there. 
# Do NOT edit this file itself to customize it for your computer, 
# since this is under version control and thus your edits would just
# conflict with other users changing this same file too.
#
# Source this file from your .bash_profile or .bashrc (see pipeline configuration instructions)


#----- Required paths (editing required) --------------------
# GPI_DATA_ROOT is a helper path only.  If desired you can set 
# all paths independently. For example, 
# export GPI_DRP_QUEUE_DIR="/home/labuser1/GPI/data/queue" 

# instances of /home/labuser1/GPI should be replaced with the users directory structure of choice

# the user is **REQUIRED** to set the GPI_DATA_ROOT directory, 
# then create the queue, Detector, and Reduced subdirectories 
# (although the user can rename them to their chosing)

export GPI_DATA_ROOT="/home/labuser1/GPI/data/"      # base dir for all data  ** CHANGE REQUIRED**
export GPI_DRP_QUEUE_DIR="${GPI_DATA_ROOT}/queue/"      # where is the DRP Queue directory?
export GPI_RAW_DATA_DIR="${GPI_DATA_ROOT}/Detector/"    # where is raw data?
export GPI_REDUCED_DATA_DIR="${GPI_DATA_ROOT}/Reduced/" # where should we put reduced data?


#---- Optional paths (not genererally needed) -------
# these variables are optional - you may omit them if your 
# drp setup is standard
#export GPI_DRP_DIR="/home/labuser1/GPI/pipeline"  # pipeline code location (contains subdirectories backbone, config, gpitv etc.)
#export GPI_DRP_CONFIG_DIR="${GPI_DRP_DIR}/config/"          # default config settings (no change required)
#export GPI_DRP_TEMPLATES_DIR="${GPI_DRP_DIR}/recipe_templates"	# pipeline DRF template location (no change required)


# the user is **REQUIRED** to create the calibrations and logs subdirectories
#export GPI_DRP_CALIBRATIONS_DIR="${GPI_REDUCED_DATA_DIR}/calibrations/"	# pipeline calibration location
#export GPI_DRP_LOG_DIR="${GPI_REDUCED_DATA_DIR}/logs/"	                    # default log dir

#---- DST install only (optional) -----
#export GPI_DST_DIR="${GPI_CODE_ROOT}/dst/"	 

#---------- make sure the startup scripts are in your $PATH   -----a
#           and the IDL code is in your $IDL_PATH
# 
export IDL_PATH="+/home/labuser1/GPI/:${IDL_PATH}" #  ** CHANGE REQUIRED** location of the pipeline and external directories
export PATH="${PATH}:/home/labuser1/GPI/pipeline/scripts"	#  ** CHANGE REQUIRED** the scripts directory located in the pipeline directory which is located in the directory declared just above



